// la prsentation

#include "aw.h"
#include <time.h>
#include <string.h>

/*
======================================================
LISTE DES FONCTIONS DU MODULE :                     ==
======================================================
void pos::read(ifstream& f_in)                      ==
void pos::print(ofstream& fout)                     ==
int pos::getjeu()                                   ==
void pos::getjoueur()                               ==
void pos::getposition()                             ==
void pos::affiche(char ajouer)                      ==
void tpos::place(char nombre)                       ==
void tpos::affiche(int position, COLORS coul)       ==
void cadre()                                        ==
int getelague()                                     ==
void gotoerreur()                                   ==
int getniveau()                                     ==
int getfenetre()                                    ==
void gotojeu()                                      ==
void printtime (ostream& out)                       ==
char nouvellepartie();                              ==
======================================================
*/

#define ligneJeu    23
#define ligneErreur 24

class tpos
{ public :
  char w[7][7];
  void place(char);
  void affiche (int position, COLORS=BLUE);
};

void pos::affiche(char ajouer)
{ tpos unecase;
  int c;
  if (ajouer==-10)
  { for (c=0; c<12; c++)
	 { unecase.place(n[c]);
		unecase.affiche(c);
	 }
	 gotoxy(1,4);
    for (c=0; c<gain[1]; c++)
	 { if (c%4==0) cout << ' ';
      cout << " ";
    }
    clreol();

	 gotoxy(1,22);
    for (c=0; c<gain[0]; c++)
	 { if (c%4==0) cout << ' ';
      cout << " ";
    }
      clreol();
  }
  else
  { char main;
	 c = ajouer;
	 pos bidon = (*this);
	 unecase.place(0);
	 unecase.affiche(ajouer);
	 for (main=n[ajouer]; main>0; main--)
	 { c=next(c);
		if (c==ajouer) c=next(c);
		bidon.n[c]++;
		unecase.place(bidon.n[c]);
		unecase.affiche(c);
	 }
	 bidon = (*this);
    bidon.symetrique();
	 bidon.joue(ajouer);
	 unecase.place(0);
	 for (c=queue(campadverse()); c>=tete(campadverse()); c--)
	 { if (bidon.n[c]==0) unecase.affiche(c);
	 }
	 if (gain[1]!=bidon.gain[1])
	 { gotoxy(1,4); for (c=0; c<bidon.gain[1]; c++)
		{ if (c%4==0) cout << ' '; cout << " "; }
      clreol();
    }
	 if (gain[0]!=bidon.gain[0])
	 {	gotoxy(1,22); for (c=0; c<bidon.gain[0]; c++)
		{ if (c%4==0) cout << ' '; cout << " "; }
      clreol();
	 }
  }
  return;
};

void tpos::place(char nombre)
{ if (nombre>42) return; // pas de place
  float a, x, y, x1, y1;
  int x2, y2;
  char ok, i, j, pion;
  for (i=0; i<7;i++) for (j=0; j<7;j++) w[i][j]=0;
  if (nombre==0) return;
  w[3][3]=1;
  if (nombre==1) return;
  for (pion=1; pion<nombre; pion++)
  { do // tirage d'un angle et calcul position
    { ok=1; // rentre dans le carr
      a=random(450)*3.14159/1800 ; // angle entre 0 et 45
      y = tan(a); x = 1;
      if (random(2)) { x1=x; y1=y; } else { x1=y; y1=x; }
      if (random(2)) x1 = -x1;
      if (random(2)) y1 = -y1;
      int coef=1;
      do  // cherche la position prs du centre
      { if (coef>3) { ok=0; break; }
        x2 = x1*coef+3; y2=y1*coef+3; coef++;
        if (x2==6) { ok=0; break; }
      } while ( !(w[x2][y2]==0)  );
    } while (!ok);
    // rapproche du centre
    char bouge;
    do
    { int d1 = (x2-3)*(x2-3)+(y2-3)*(y2-3), d2;
      int i,j;
      bouge=0;
      for (i=-1; i<=1; i++)
      { for (j=-1; j<=1; j++)
        { d2 = (x2-3+i)*(x2-3+i)+(y2-3+j)*(y2-3+j);
          if ( d2 < d1 && w[x2+i][y2+j]==0 )
          { x2+=i; y2+=j; bouge=1; break; }
        }
        if (bouge) break;
      }
    } while (bouge);
    w[x2][y2]=1;
  }
  return;
};

void tpos::affiche(int position, COLORS coul)
{ int i,j, camp, cx, cy;
  camp = ((position-6)>=0)*2-1;
  cy = 13-4*camp;
  if(camp==1) cx=11-position; else cx=position;
  cx = 9+13*cx;
  for (i=0; i<7; i++)
  { gotoxy(cx-7, cy+i-3);
    if (i%2==0) cout << ' ';
    for (j=0; j<6; j++)
    { if (w[j][i])
      { if (random(2))
        { cprintf("");
        }
        else
        { cprintf("");
        }
      }
      else
      { cout << ' ';
      }
      if (j<5)
      { cout << ' ';
      }
    }
    cout << '\n';
  }
  return;
}

void cadre()
{ int x,y;
  char* bord = "ɻȼ̹";
  text_info before;
  gettextinfo(&before);
  clrscr();
  gotoxy(1,5);
  for (x=1; x<=80; x++) for (y=5;y<=21; y++) cprintf(" ");
  for (x=1; x<80; x+=13) for (y=5; y<=21; y++) { gotoxy(x,y); cout << bord[0]; }

  for (x=1; x<80; x++) for (y=5; y<=21; y+=8)
  { gotoxy(x,y);
    if ((x-1)%13 == 0)
    {      if (x==1 && y==5) cout << bord[1];
      else if (x==79 && y==5) cout << bord[2];
      else if (x==1 && y==21) cout << bord[3];
      else if (x==79 && y==21) cout << bord[4];
      else if (y==5) cout << bord[5];
      else if (y==13)
      { if (x==1) cout << bord[6];
        else if (x==79) cout << bord[7];
        else cout << bord[8];
      }
      else if (y==21) cout << bord[9];
    }
    else cout << bord[10]; }
    for (x=0; x<6; x++) { gotoxy(7+13*x,5); cout << (11-x); }
    for (x=0; x<6; x++) { gotoxy(7+13*x,21); cout << x; }
  textattr(before.attribute);
  return;
};

void gotojeu()
{ gotoxy(30,ligneJeu);
  clreol();
};

void gotoerreur()
{ gotoxy(30,ligneErreur);
  clreol();
};

int getniveau()
{ int reponse;
  gotojeu(); cout << "niveau : ";
  cin >> reponse;
  return reponse;
};

int getfenetre()
{ int reponse;
  gotojeu(); cout << "fentre alpha : ";
  cin >> reponse;
  return reponse;
};

int getelague()
{ int reponse;
  gotojeu(); cout << "fentre d'laguage : ";
  cin >> reponse;
  return reponse;
};

char pos::getposition()
{ char automanu, ok;
  do
  { gotojeu(); cout << "position initiale auto/manuel (a/m) : ";
    cin>>automanu;
  } while (automanu!='a' && automanu!='m' && automanu!= 'f');
  switch (automanu) {
  case 'm':
    do
    { int ent, i;
      for (i=0; i<12; i++) n[i]=0;
      for (i=11; i>5; i--)
	   { gotojeu();
        cout << "haut "<< i << ">";
        cin >> ent; n[i]=ent;
        tpos unecase;
        unecase.place(n[i]);
        unecase.affiche(i);
      }
      for (i=0; i<6; i++)
	   { gotojeu();
        cout << "bas"<< i << ">";
        cin >> ent; n[i]=ent;
        tpos unecase;
        unecase.place(n[i]);
        unecase.affiche(i);
      }
	   gotojeu(); cout << "vos gains>"; cin >> ent; gain[0]=ent; affiche();
	   gotojeu(); cout << "mes gains>"; cin >> ent; gain[1]=ent; affiche();
      do
      { gotojeu(); cout << "OK ? (o/n) > "; cin >> ok; }
      while (!(ok=='o' || ok=='n'));
    } while (!(ok=='o'));
    break;
  case 'a':
    raz();
    affiche();
    break;
  case 'f':
    gotojeu();
    cout << "fichier>";
    char nf[100];
    cin >> nf;
    ifstream in(nf);
    read(in);
    in.close();
    affiche();
    break; }
  return (automanu=='a');
};

void pos::getjoueur()
{ char r;
  do { gotojeu(); cout << "qui joue ? (h=haut, b=bas)>"; cin>>r; }
  while (!(r=='h' || r=='b'));
  if (r=='h')
  { quijoue=1; }
  else
  { quijoue=-1; }
};

int pos::getjeu()
{ int caseajouer;
  int ok;
  do
  { gotojeu();                                       // ligne jeu. laisser le message
    cout << "jeu : ";                                // affiche message
    cin >> caseajouer;                               // saisi jeu
    gotojeu();                                       // efface le message
    gotoerreur();                                    // efface un ventuel message d'erreur
    if (caseajouer==-10)
    { cadre();
      affiche();
      ok=0;
      continue;
    }
    else if (caseajouer ==-100)
    { break; }
    else if (!estjeu(caseajouer))
    { gotoerreur();
      cout << "COUP IMPOSSIBLE OU INTERDIT";
      ok=0;
      continue;
    }
    else
    { ok=1;
      affiche(caseajouer);
      joue(caseajouer);
    }
  } while (!ok);
  return caseajouer;
};

void pos::print()
{ ofstream fout("awchrono.xls", ios::app);
  fout << -99 << '\t';
  for (int i=0; i<12; i++) fout << int(n[i]) << '\t';
  fout << '\t' << int(gain[0]) << '\t' << int(gain[1]) << '\t' << int(quijoue) << '\t';
  fout.close();
};

void pos::read(ifstream& f_in)
{ int x;
  do { f_in >> x; } while (x != -99);
  for (int i=0; i<12; i++) { f_in >> x; n[i]=x ; }
  f_in >> x; gain[0]=x;
  f_in >> x; gain[1]=x;
  f_in >> x; quijoue=x;
};

void printtime (ostream& out)
{ time_t timer;
  struct tm *tblock;
  timer = time(NULL);
  tblock = localtime(&timer);
  char* date = asctime(tblock);
  date[strlen(date)-1]=' ';
  out << date;
};

char* getmessage()
{ static char buff[254];
  gotojeu();
  cout << "Votre nom >";
  cin.get(buff, 253);
  char fin;
  cin.get (fin);
  return buff;
};

void printheader()
{ ofstream fout("awchrono.xls", ios::app);
  fout << '\n';
  char* a = getmessage();
  printtime(fout);
  fout << a << '\n';
  fout.close();
};

char nouvellepartie()
{ char c;
  gotojeu();
  cout <<"nouvelle partie (o/n) ? ";
  do cin>>c;
  while (c!='o' && c!='n');
  return (c=='o');
};