// la fonction d'valuation

// voir en bas note sur les finales.

#include "aw.h"

char finale;
extern unsigned nterm;

#define avoirgagne   10000         // avoir gagn
#define avoirMange     100         // valeur de l'avantage matriel existant
#define bloquer        100         // les prises certaines  terme
                               // en finale seulement :
#define marcher        135         // l'avantage des marches
#define unemarche        1         // une marche

int pos::evalue()
// quijoue DOIT ETRE NON NUL
{ nterm++;
  int result=0;
  statut=0;
  Tableau arriv, aprendr;
  char tc=tete(camp());
  char ta=tete(campadverse());
  char g[2]; // gains rels
  g[0]=gain[0];
  g[1]=gain[1];

  
  // ____________________________
  // LA PARTIE EST-ELLE BLOQUEE ?
  // ----------------------------
  if (                                   // si 
     n[ta]==0 && n[ta+1]==0              // camp adverse vide
  && n[ta+2]==0 && n[ta+3]==0            //
  && n[ta+4]==0 && n[ta+5]==0            //
  && n[tc]<6 && n[tc+1]<5                // et aucune case du camp qui joue
  && n[tc+2]<4 && n[tc+3]<3              // n'atteint le camp adverse
  && n[tc+4]<2 && n[tc+5]<1              //
  )                                      // alors :
  { g[campadverse()]++;                  // 1 pion pour l'adversaire
    g[camp()]=48-g[campadverse()];       // le reste pour moi
    statut |=4;                          // la partie est dfinitivement finie
  }
  else
  { statut &= 0xFB;                     // raz bit bloquage
    if ( finale ||
    ( g[0]+g[1] > 32 ) )
    { finale = 1; 
      if ( n[5]==0 && n[11]==0           // si la finale est symtrique
      && n[4]==0 && n[10]==0
      && n[3]<2 && n[3]==n[9]
      && n[2]<2 && n[2]==n[8]
      && n[1]<2 && n[1]==n[7]
      && n[0]<2 && n[0]==n[6])
      { g[0]+=(48-g[0]-g[1])/2;
        g[1]=48-g[0];
      }
    }
  } // fin de if (bloque) else if (symtrique)
  // je n'ai rien fait si ni bloqu ni symtrique

  if (g[camp()]>=24) statut|=1;         //
  if (g[campadverse()]>=24) statut|=2;  //

  // ______________________________________________________________
  // EVALUATION COMMUNE A TOUS LES CAS Y COMPRIS LES PARTIES FINIES
  // --------------------------------------------------------------
  // avoir mang : avantage matriel acquis
  result += avoirMange *
  (g[camp()]-g[campadverse()]);

  // avoir gagn
  if (gagne()) result += avoirgagne;      // gagne au sens strict
  else if (perd()) result -= avoirgagne;  // perd au sens strict

  // si la partie est bloque, l'valuation est suffisante
  // dans tous les autres cas, il faut valuer correctement pour finaliser.
  if (bloque()) return result;

  // calcul des tableaux arriv et aprendr
  arrivees(arriv);
  aprendre(aprendr, arriv);

  // __________________________
  // SI LA PARTIE EST EN FINALE
  // --------------------------
  if ( finale==1)
  {
    // marcher 
    char mesmarches = marches(camp());
    char sesmarches = marches(campadverse());
    result += (mesmarches-sesmarches) * unemarche;

    // marcher plus
    result += ((mesmarches>sesmarches)?1:(-1)) * marcher;
  }

  else // pas en finale

  // ____________________________________
  // TRAITEMENT DES PARTIES NON EN FINALE
  // ------------------------------------
  { Tableau risqu, attaq;

    // bloquer : gain certain  terme
    risque(risqu, attaq, aprendr);
    result += ( maxi (risqu, campadverse())
              - maxi (risqu, camp()) ) * bloquer;
  }
  return result;
}

/*

FINALES A PIONS GROUPES EN QUEUE
4 contre 3 :
3 joue et gagne tout.
4 joue, peut faire un change avec la complicit de 3.
Il lui reste de faon stable 1 pion dans son camp et 2 dans l'autre.
Donc : 4 joue et ramasse 3

2 contre 1 :
2 n'aura plus rien. jeu bloqu.
*/